<?php

/**
 * @file
 * Contains \Drupal\url_restrictions\EventSubscriber\UrlRestrictions.
 */

namespace Drupal\url_restrictions\EventSubscriber;

use Symfony\Component\HttpKernel\KernelEvents;
use Symfony\Component\HttpKernel\Event\GetResponseEvent;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Drupal\Core\Cache\CacheableMetadata;
use Drupal\Core\Routing\TrustedRedirectResponse;

use \Drupal\Core\Url;

/**
 * Event Subscriber for Url Restrictions.
 */
class UrlRestrictions implements EventSubscriberInterface { 
  /**
   * Code that should be triggered on event specified 
   */
  public function onRespond(GetResponseEvent $event) {
   
    $userpage = ['node' , 'taxonomy'];
    $response = $event->getResponse();    
    $request_uri = \Drupal::request()->server->get('REQUEST_URI');
    $path = explode("/" , $request_uri); 
    $arr_entity_tpye = \Drupal::config('url_restrictions.settings')->get('entity_tpye');
    $redirect_path = \Drupal::config('url_restrictions.settings')->get('url');
    $pages = \Drupal::config('url_restrictions.settings')->get('pages');     
    $pages = explode(PHP_EOL ,$pages); 
    
    $role = \Drupal::currentUser()->getRoles();
    
    if(!in_array('administrator' , $role)) {
      if(isset($path[1]) && in_array($path[1] , $arr_entity_tpye , TRUE) && $request_uri != $redirect_path) { 
        if(!in_array($request_uri, $pages)) {
           $response = new TrustedRedirectResponse($redirect_path);
           $response->addCacheableDependency(CacheableMetadata::createFromRenderArray([])->addCacheTags(['rendered']));
           $event->setResponse($response);
        }
      }
    }    
  }
  

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents() {    
    $events[KernelEvents::REQUEST][] = ['onRespond'];
    return $events;
  }

}